(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define("snoopy", [], factory);
	else if(typeof exports === 'object')
		exports["snoopy"] = factory();
	else
		root["snoopy"] = factory();
})(typeof self !== 'undefined' ? self : this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _browser = __webpack_require__(1);

var _browser2 = _interopRequireDefault(_browser);

var _cookies = __webpack_require__(2);

var _cookies2 = _interopRequireDefault(_cookies);

var _googleAnalytics = __webpack_require__(3);

var _googleAnalytics2 = _interopRequireDefault(_googleAnalytics);

var _utils = __webpack_require__(4);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var plugins = {
  browser: _browser2.default,
  cookies: _cookies2.default,
  googleAnalytics: _googleAnalytics2.default
};
Object.freeze(plugins);


var instance = null;

/**
 * Class for aynchronously sending event information to a tracker URL
 * @function
 * @param {string} name - event name
 * @param {string} trackerURL - URL to which event information is to be sent
 * @param {object} [options] = {} - object containing request options
 */

var Snoopy = function () {
  // TODO: define options keys
  function Snoopy(name, trackerURL) {
    var _this = this;

    var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

    _classCallCheck(this, Snoopy);

    this.name = name;
    this.trackerURL = trackerURL;
    this.options = options;
    this.globals = {};
    this.plugins = { before: {}, after: {} };

    if (this.options.hasOwnProperty('disabledPlugins')) {
      this.disabledPlugins = options.disabledPlugins;
    } else {
      this.disabledPlugins = {};
    }

    plugins.forEachSpecial(function (Plugin, key) {
      if (!_this.disabledPlugins.hasOwnProperty(key)) {
        var p = new Plugin(_this);
        if (p.hasOwnProperty('order')) {
          if (p.order === 'before') {
            _this.plugins.before[key] = p;
          } else {
            _this.plugins.after[key] = p;
          }
        } else {
          _this.plugins.before[key] = p;
        }
      }
    });

    if (!instance) {
      instance = this;
    }
    return instance;
  }

  /**
   * Allows setting of global parameters that will be included with every event;
   * global settings will overwrite existing params if their key exists
   * @param {object} Obj of key/values to insert into the global parameters for events
   * @throws {Error} if input parameter isn't an object
   * @returns {boolean} True if input was accepted and set in the globals object, never False
   */


  _createClass(Snoopy, [{
    key: 'set',
    value: function set(kv) {
      if (!(0, _utils.isObject)(kv)) throw Error('Invalid object');
      this.globals = (0, _utils.mergeDeep)(this.globals, kv);
    }

    /**
     * Allows removing global params by specifying path.
     * Warning: Removing a parent node will remove all children.
     * @param  {string} path - 'key1.key2.key3.key4'
     *          string literal path delimited by '.' of a key you'd like to delete
     */

  }, {
    key: 'unset',
    value: function unset(path) {
      (0, _utils.deepDelete)(path, this.globals);
    }

    /**
     * Gather and aynchronously send event information to the tracker URL
     * @function
     * @param {string} eventName
     * @param {string} eventCategory
     * @param {string} eventAction
     * @param {string} eventOrigin
     * @param {string} [eventLabel] = ''
     * @param {string} [eventValue] = ''
     * @param {string} [eventSchema] = 'latest'
     * @param {object} [data] = {} - Event object
     * @return {Promise}
     */

  }, {
    key: 'track',
    value: function track(eventName, eventCategory, eventAction, eventOrigin) {
      var eventLabel = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : '';
      var eventValue = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : '';

      var _this2 = this;

      var eventSchema = arguments.length > 6 && arguments[6] !== undefined ? arguments[6] : 'latest';
      var data = arguments.length > 7 && arguments[7] !== undefined ? arguments[7] : {};

      var eventData = Object.assign({
        eventCategory: eventCategory,
        eventAction: eventAction,
        eventLabel: eventLabel,
        eventValue: eventValue
      }, data, this.globals);

      var event = {
        eventTimestamp: (0, _utils.utc)(),
        eventUuid: (0, _utils.uuidv4)(),
        eventName: eventName,
        eventOrigin: eventOrigin || window.location.hostname,
        eventSchema: eventSchema,
        data: eventData
      };

      this.plugins.before.forEachSpecial(function (plugin) {
        event = plugin.callback(event);
      });

      this.plugins.after.forEachSpecial(function (plugin) {
        event = plugin.callback(event);
      });

      return new Promise(function (resolve, reject) {
        Snoopy.emit(event, _this2.trackerURL, _this2.options).then(function (xhr) {
          // success
          resolve([event, xhr]);
        }, function (xhr) {
          // failure
          reject([event, xhr]);
        });
      });
    }

    /**
     * Aynchronously send event information to the tracker URL
     * @function
     * @param {string} data - event object
     * @param {string} trackerURL - URL to which event information is to be sent
     * @param {object} options - object containing request options
     */

  }], [{
    key: 'emit',
    value: function emit(data, trackerURL, options) {
      return new Promise(function (resolve, reject) {
        var xhr = new XMLHttpRequest();
        xhr.open(options.method || 'POST', trackerURL);
        xhr.setRequestHeader('Content-Type', 'application/json');
        if (options.headers) {
          Object.keys(options.headers).forEachSpecial(function (key) {
            xhr.setRequestHeader(key, options.headers[key]);
          });
        }
        xhr.onload = function () {
          if (xhr.status >= 200 && xhr.status < 300) {
            resolve(xhr);
          } else {
            reject(xhr);
          }
        };
        xhr.onerror = function () {
          reject(xhr);
        };

        xhr.send(JSON.stringify(data));
      });
    }
  }]);

  return Snoopy;
}();

exports.default = Snoopy;

/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Browser = function () {
  function Browser(tracker) {
    _classCallCheck(this, Browser);

    this.tracker = tracker;
    this.userAgent = this.getUserAgent();
    this.isMobile = this.detectMobile();
    this.browserName = this.detectBrowser();
    this.order = 'before';
    return this;
  }

  _createClass(Browser, [{
    key: 'getUserAgent',
    value: function getUserAgent() {
      return navigator.userAgent;
    }
  }, {
    key: 'detectMobile',
    value: function detectMobile() {
      var isMobile = false;
      if (/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|ipad|iris|kindle|Android|Silk|lge |maemo|midp|mmp|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows (ce|phone)|xda|xiino/i.test(this.getUserAgent())) {
        isMobile = true;
      }
      return isMobile;
    }
  }, {
    key: 'detectBrowser',
    value: function detectBrowser() {
      var ua = navigator.userAgent;
      var tem = void 0;
      var M = ua.match(/(opera|chrome|safari|firefox|msie|trident(?=\/))\/?\s*(\d+)/i) || [];
      if (/trident/i.test(M[1])) {
        tem = /\brv[ :]+(\d+)/g.exec(ua) || [];
        return 'IE ' + (tem[1] || '');
      }
      if (M[1] === 'Chrome') {
        tem = ua.match(/\b(OPR|Edge)\/(\d+)/);
        if (tem != null) return tem.slice(1).join(' ').replace('OPR', 'Opera');
      }
      M = M[2] ? [M[1], M[2]] : [navigator.appName, navigator.appVersion, '-?'];
      if (ua.match(/version\/(\d+)/i) != null) M.splice(1, 1, tem[1]);
      return M.join(' ');
    }
  }, {
    key: 'callback',
    value: function callback(event) {
      event.data.browser = {
        appName: navigator.appName,
        userAgent: this.userAgent,
        isMobile: this.isMobile,
        language: navigator.language,
        platform: navigator.platform,
        browserName: this.browserName
      };
      return event;
    }
  }]);

  return Browser;
}();

exports.default = Browser;

/***/ }),
/* 2 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Cookies = function () {
  function Cookies(tracker) {
    _classCallCheck(this, Cookies);

    this.tracker = tracker;
    this.cookies = this.getCookies();
    this.order = 'after';
    return this;
  }

  _createClass(Cookies, [{
    key: 'getCookies',
    value: function getCookies() {
      var pairs = document.cookie.split(';');
      var cookies = {};
      for (var i = 0; i < pairs.length; i += 1) {
        var pair = pairs[i].split('=');
        cookies[pair[0].trim()] = decodeURIComponent(pair[1]);
      }
      return cookies;
    }
  }, {
    key: 'callback',
    value: function callback(event) {
      event.data.cookies = {
        cookies: this.cookies
      };
      return event;
    }
  }]);

  return Cookies;
}();

exports.default = Cookies;

/***/ }),
/* 3 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * Aynchronously send event information to the tracker URL
 * @function
 * @param {string} eventName
 * @param {string} eventCategory
 * @param {string} eventAction
 * @param {string} eventOrigin
 * @param {string} [eventLabel] = ''
 * @param {string} [eventValue] = ''
 * @param {string} [eventSchema] = 'latest'
 * @param {object} [data] = {} - Event object
 * @return {Promise}
 */
var GoogleAnalytics = function () {
  function GoogleAnalytics() {
    _classCallCheck(this, GoogleAnalytics);
  }

  _createClass(GoogleAnalytics, [{
    key: "callback",
    value: function callback(thisEvent) {
      window.dataLayer = window.dataLayer || [];
      var gaData = Object.assign({
        event: thisEvent.eventName,
        eventCategory: thisEvent.data.eventCategory,
        eventAction: thisEvent.data.eventAction,
        eventValue: thisEvent.data.eventValue,
        eventLabel: thisEvent.data.eventLabel,
        eventSchema: thisEvent.eventSchema,
        eventTimestamp: thisEvent.eventTimestamp,
        eventUuid: thisEvent.eventUuid,
        eventOrigin: thisEvent.eventOrigin
      }, thisEvent.data);
      window.dataLayer.push(gaData);
      return thisEvent;
    }
  }]);

  return GoogleAnalytics;
}();

exports.default = GoogleAnalytics;

/***/ }),
/* 4 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

exports.utc = utc;
exports.uuidv4 = uuidv4;
exports.isObject = isObject;
exports.mergeDeep = mergeDeep;
exports.deepDelete = deepDelete;

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function utc() {
  return Math.floor(new Date().getTime());
}

function uuidv4() {
  if (typeof crypto !== 'undefined') {
    return ([1e7] + -1e3 + -4e3 + -8e3 + -1e11).replace(/[018]/g, function (c) {
      return (c ^ crypto.getRandomValues(new Uint8Array(1))[0] & 15 >> c / 4).toString(16);
    });
  }
  return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
    var r = Math.random() * 16 | 0,
        v = c === 'x' ? r : r & 0x3 | 0x8;
    return v.toString(16);
  });
}

function isObject(item) {
  return item && (typeof item === 'undefined' ? 'undefined' : _typeof(item)) === 'object' && !Array.isArray(item);
}

function mergeDeep(target, source) {
  var output = Object.assign({}, target);
  if (isObject(target) && isObject(source)) {
    Object.keys(source).forEachSpecial(function (key) {
      if (isObject(source[key])) {
        if (!(key in target)) {
          Object.assign(output, _defineProperty({}, key, source[key]));
        } else {
          output[key] = mergeDeep(target[key], source[key]);
        }
      } else {
        Object.assign(output, _defineProperty({}, key, source[key]));
      }
    });
  }
  return output;
}

function deepDelete(path, context) {
  var targets = path.split('.');

  if (targets.length > 1) {
    deepDelete(targets.slice(1).join('.'), context[targets[0]]);
  } else {
    delete context[path];
  }
}

/**
 * Object.prototype.forEachSpecial() polyfill
 * https://gomakethings.com/looping-through-objects-with-es6/
 * @author Chris Ferdinandi
 * @license MIT
 */
if (!Object.prototype.forEachSpecial) {
  Object.defineProperty(Object.prototype, 'forEachSpecial', {
    value: function value(callback, thisArg) {
      if (this == null) {
        throw new TypeError('Not an object');
      }
      thisArg = thisArg || window;
      for (var key in this) {
        if (this.hasOwnProperty(key)) {
          callback.call(thisArg, this[key], key, this);
        }
      }
    }
  });
}

/***/ })
/******/ ]);
});
//# sourceMappingURL=snoopy.js.map