class Browser {
  constructor(tracker) {
    this.tracker = tracker;
    this.userAgent = this.getUserAgent();
    this.isMobile = this.detectMobile();
    this.browserName = this.detectBrowser();
    this.order = 'before';
    return this;
  }

  getUserAgent() {
    return navigator.userAgent;
  }

  detectMobile() {
    let isMobile = false;
    if (/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|ipad|iris|kindle|Android|Silk|lge |maemo|midp|mmp|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows (ce|phone)|xda|xiino/i.test(this.getUserAgent())) {
      isMobile = true;
    }
    return isMobile;
  }

  detectBrowser() {
    const ua = navigator.userAgent;
    let tem;
    let M = ua.match(/(opera|chrome|safari|firefox|msie|trident(?=\/))\/?\s*(\d+)/i) || [];
    if (/trident/i.test(M[1])) {
      tem = /\brv[ :]+(\d+)/g.exec(ua) || [];
      return `IE ${(tem[1] || '')}`;
    }
    if (M[1] === 'Chrome') {
      tem = ua.match(/\b(OPR|Edge)\/(\d+)/);
      if (tem != null) return tem.slice(1).join(' ').replace('OPR', 'Opera');
    }
    M = M[2] ? [M[1], M[2]] : [navigator.appName, navigator.appVersion, '-?'];
    if ((ua.match(/version\/(\d+)/i)) != null) M.splice(1, 1, tem[1]);
    return M.join(' ');
  }

  callback(event) {
    event.data.browser = {
      appName: navigator.appName,
      userAgent: this.userAgent,
      isMobile: this.isMobile,
      language: navigator.language,
      platform: navigator.platform,
      browserName: this.browserName,
    };
    return event;
  }
}

export default Browser;
